//
// Jing Chan '02-'03
// MMORPG - particle.c
// Particle engine handling
//

#include "pork.h"

struct Effect* Effects[MAX_EFFECTS];


void drawRail( vec3 start, vec3 end, vec3 colorLine, vec3 colorTrail )
{
	/*
	glBegin(GL_LINES);
	glColor3fv(colorLine);
	glVertex3fv(start);
	glVertex3fv(end);
	glVertex3f(0, 0, 200);
	glEnd();
	*/

	drawBlock(start, end, 2);

	vec3 temp;
	VectorSub(end, start, temp);
	vec1 dist = VectorMagnitude(temp);
	vec1 i;
	vec1 r;
	r=.4;
	
	
	glPushMatrix();
	glTranslatef(PC.pos[0], PC.pos[1], PC.pos[2]+1);
	
	glRotatef(PC.theta/M_PI*180-90, 0, 0, -1);
	glRotatef(PC.phi/M_PI*180-90, 0, 1, 0);
	glBegin(GL_LINE_STRIP);
		for(i=0; i<dist; i+=.01){
			glColor3fv(colorTrail);
			glVertex3f(i, r*cos(i*3), r*sin(i*3));
			//glVertex3f(i+1, r*cos(i), r*sin(i));
		}
	glEnd();
	glPopMatrix();

}


/*
PC.pos[0] -= 5*view[1]*deltat/1000;
PC.pos[1] += 5*view[0]*deltat/1000;
*/

P_Source* Particle_Sources[MAX_PSOURCES];

void pInit()
{
	int i;
	for(i=0; i<MAX_PSOURCES; i++){
		Particle_Sources[i]=NULL;
	}
	static vec3 blah1 = {0, 0, 1};
	static vec3 blah2 = {10, 0, 1};
	static vec3 blah3 = {10, 10, 1};
	static vec3 blah4 = {0, 10, 1};
	psCreate( &blah1 );
//	psCreate( &blah2 );
//	psCreate( &blah3 );
//	psCreate( &blah4 );
//	psCreate( &(PC.pos) );

}

void psCreate( vec3* pos ) //P_Source* a )
{
	int i, j;
	for(i=0; i<MAX_PSOURCES; i++){
		if(!Particle_Sources[i]){
			Particle_Sources[i] = new P_Source;

			Particle_Sources[i]->freq = 10.0;
			Particle_Sources[i]->time = 0.0;

			Particle_Sources[i]->pos = pos;

			//Particle_Sources[i]->vel[0] = 0.0;
			//Particle_Sources[i]->vel[1] = 0.0;
			//Particle_Sources[i]->vel[2] = 0.0;

			//Particle_Sources[i]->accel[0] = 0.0;
			//Particle_Sources[i]->accel[1] = 0.0;
			//Particle_Sources[i]->accel[2] = 0.0;

			Particle_Sources[i]->p_vel[0] = 0.0;
			Particle_Sources[i]->p_vel[1] = 0.0;
			Particle_Sources[i]->p_vel[2] = 0.0;

			Particle_Sources[i]->p_accel[0] = 0.0;
			Particle_Sources[i]->p_accel[1] = 0.0;
			Particle_Sources[i]->p_accel[2] = 0.0;

			Particle_Sources[i]->p_life = 5.0;

			for(j=0; j<MAX_PARTS; j++){
				Particle_Sources[i]->parts[j].life = 0.0;
			}
			break;
		}
	}
	return;

}

void psDestroy( vec3* pos )
{
	int i;
	for(i=0; i<MAX_PSOURCES; i++){
		if(Particle_Sources[i])
		if(Particle_Sources[i]->pos==pos){
			delete Particle_Sources[i];
			Particle_Sources[i] = NULL;
		}
	}
}

/*
void psDestroy( P_Source* &a )
{
	delete a;
	a = NULL;
}
*/

void psUpdate( vec1 deltat )
{
	int i;
	for(i=0; i<MAX_PSOURCES; i++){
		if(Particle_Sources[i]){
			pUpdate(Particle_Sources[i], deltat);
		}
	}
}

void pUpdate( P_Source* a, vec1 deltat )
{
	int i;
	vec3 temp;
	
	a->time += deltat;
	while(a->time > 1/a->freq){
		pMake(a);
		a->time-=1/a->freq;	
	}




	for(i=0; i<MAX_PARTS; i++){
		if(a->parts[i].life > 0.0){

			VectorMul( deltat, a->parts[i].vel, temp );
			VectorAdd( a->parts[i].pos, temp, a->parts[i].pos );
			VectorMul( deltat, a->p_accel, temp );
			VectorAdd( a->parts[i].vel, temp, a->parts[i].vel );

			a->parts[i].life -= deltat;
		}
	}
}


void pMake( P_Source* a )
{
	int i;
	vec1 phi, theta;
	for(i=0; i<MAX_PARTS; i++){
		if(!(a->parts[i].life > 0.0)){
			a->parts[i].life = a->p_life;

			VectorCopy(a->parts[i].pos, *(a->pos));
			VectorCopy(a->parts[i].vel, a->p_vel);

			theta = ((float)rand()/RAND_MAX)*2*M_PI;
			phi = ((float)rand()/RAND_MAX)*2*M_PI;

			a->parts[i].vel[0] += .5*cos(theta)*sin(phi); //2*((float)rand()/RAND_MAX - .5);
			a->parts[i].vel[1] += .5*sin(theta)*sin(phi); //2*((float)rand()/RAND_MAX - .5);
			a->parts[i].vel[2] += .5*cos(phi); //2*((float)rand()/RAND_MAX - .5);

			break;
		}
	}
	return;
}


void psDraw( )
{
	int i;
	for(i=0; i<MAX_PSOURCES; i++){
		if(Particle_Sources[i]){
			pDraw(Particle_Sources[i]);
		}
	}
}

void pDraw( P_Source* a )
{
	int i;
	glBegin(GL_POINTS);
	glColor3f(1, 1, 1);
	for(i=0; i<MAX_PARTS; i++){
		if(a->parts[i].life > 0.0){
			//glVertex3f(0,0,0);
			glVertex3fv(a->parts[i].pos);
		}
	}
	glEnd();
}

Proj* ProjectileList[MAX_PROJ];

void projInit()
{
	int i;
	for(i=0; i<MAX_PROJ; i++){
		ProjectileList[i]=NULL;
	}
}

void projCreate( vec3 pos, vec3 vel )
{
	int i;
	for(i=0; i<MAX_PROJ; i++){
		if(!ProjectileList[i]){
			ProjectileList[i] = new Proj;
			VectorCopy(ProjectileList[i]->pos, pos);
			VectorCopy(ProjectileList[i]->vel, vel);

			psCreate(&ProjectileList[i]->pos);
			break;
		}
	}
}

void projDestroy( Proj* &a )
{

	psDestroy(&a->pos);
	delete a;
	a = NULL;
}

void projUpdate( vec1 deltat )
{
	int i;
	vec3 temp;
	for(i=0; i<MAX_PROJ; i++){
		if(ProjectileList[i]){
			VectorMul(deltat, ProjectileList[i]->vel, temp);
			VectorAdd(ProjectileList[i]->pos, temp, ProjectileList[i]->pos);
			if(ProjectileList[i]->pos[2] < worldHeight(ProjectileList[i]->pos[0], ProjectileList[i]->pos[1])){
				projDestroy(ProjectileList[i]);
			}
		}
	}
}

void projDraw( )
{
	int i;
	for(i=0; i<MAX_PROJ; i++){
		if(ProjectileList[i]){
			drawBox(ProjectileList[i]->pos);
		}
	}
}
